var express = require('express'),
	app = express.createServer(),
	Blog = require('../../lib/blogjs');

app.configure('test', function() {
	app.use(express.bodyParser());
	app.use(app.router);
	app.use(express.static(__dirname + '/public'));
    app.use(express.errorHandler({ dumpExceptions: true, showStack: true })); 
});

var blog = new Blog();

/**
 * RESTful blog routes
 */
app.get('/blog/post/:id.json', function(req, res) {
	blog.findPost({
		id: req.params.id
	},
	function(err, post){
		if(err) {
			return res.send(404);	
		}
		res.send(post);
	});
});

app.get('/blog/summaries.json', function(req, res, next) {
	blog.findSummaries({
		text: 'backbone',
		limit: 10	
	}, function(err, summaries) {
		res.send(summaries);
	});
});

app.listen(3000);
