/**
 * BLOGJS TODOS CHEKCLIST:
 * 1. SEO capability
 */
var fs = require('fs'),
	path = require('path');

var Blog = function(options) {
	var options = options || {};
	this.limit = options.limit || 10;
	this.postsFolder = options.postsFolder || 'posts';

	var raw = this._readIndex(); 
	this._index = this._convert(raw);
}

Blog.prototype._readIndex = function() {
	var indexPath = path.join(this.postsFolder, 'post.idx');
	return fs.readFileSync(indexPath, encoding='utf8');
};

Blog.prototype._convert = function(raw) {
	var posts = [], 
    postBlockBeginReg = /#([a-zA-Z0-9_]+)\s*\{/,
    postBlockEndReg = /\}/,
    propertyReg = /"([a-zA-Z0-9_]+)"\s*:\s*"(.*)";?/;

	state = 'INIT',
	curPost = {}, 

    lines = raw.split('\n');
	for(var i=0;i<lines.length;i++) {
		var line = lines[i],
			postBlockBeginToken = line.match(postBlockBeginReg),
			propertyToken = line.match(propertyReg),
			postBlockEndToken = line.match(postBlockEndReg);  

		if(state == 'INIT' && postBlockBeginToken) {
			state = 'INSIDE_POST';
			curPost["id"] =  postBlockBeginToken[1];
			continue;
		}   

		if(state == 'INSIDE_POST' && propertyToken) {
			curPost[propertyToken[1]] = propertyToken[2];
			continue;
		}   

		if(state == 'INSIDE_POST' && postBlockEndToken) {
			state = 'INIT';
			var newPost = curPost;
			posts.push(newPost);
			curPost = {}; 
		}   
	}
	return posts;
};

Blog.prototype._readPost = function(summary, callback) {
	var	post = {
			id: summary.id,
			title: summary.title,
			markup: ''
		},
		postPath = path.join(this.root,
			this.postsFolder, summary.path);

	fs.readFile(postPath, encoding='utf8', function(err, markup) {
		if(err) {
			return callback( new Error('Post markup not found') );
		}
		post.markup = markup;
		callback(null, post);	
	});
};

Blog.prototype.findPost = function(params, callback) {
	var index = this._index,
	 	indexSize = index && index.length;

	if (indexSize) {

		var postId = params.id === 'latest' ?
			indexSize : params.id;
		for (var i = 0; i < indexSize; i++) {
			var s = index[i];
			if(s.id == postId){
				return this._readPost(s, callback);
			}
		}
    }

	callback(new Error('Post not found'));
};

Blog.prototype.findSummaries = function(params, callback) {
	var summaries = [];
	this._index.forEach(function(postMeta) {
		summaries.push({
			id: postMeta.id,
			title: postMeta.title,
			description: postMeta.summary || ""
		});
    }); 
	callback(null, summaries);
}


module.exports = Blog;
